﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10.7
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Public SQL As SQL
	Public Utility As UtilityClass
	Private cmdExport As Button
	Private cmdImport As Button
	Private cmdPermissions As Button
	Private Storage As ExternalStorage
	Private rr As RuntimePermissions
	
	'Public db As SQL
End Sub


'You can add more parameters here.
Public Sub Initialize As Object
	Utility.Initialize()
End Sub


'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Storage.Initialize (Me, "Storage")
	
	Root = Root1
	Root.LoadLayout("DBTools")		'load the layout to Root
End Sub


Private Sub B4XPage_Appear

	Utility.Initialize()

End Sub


Private Sub cmdPermissions_Click
	rr.CheckAndRequest(rr.PERMISSION_READ_EXTERNAL_STORAGE)
	Wait For Activity_PermissionResult (Permission As String, Result As Boolean)

	If Result = False Then
		Log("Permission denied")
		Return
	Else
		Log("Permission granted")
		Return
	End If
	
End Sub


Private Sub cmdImport_Click
	
	'MsgboxAsync(File.DirRootExternal & "/Download/", "Info")
	
	
'	'https://www.b4x.com/android/forum/threads/exitapplication-vs-activity-finish.79548/post-503759
'	'quit the app
'	Dim jo As JavaObject
'	jo.InitializeContext
'	jo.RunMethod("finishAffinity", Null)

	Dim ImportDBName As String = "data2.db"
	
	If File.Exists(File.DirRootExternal  & "/Download/", ImportDBName) = True Then
		Log("Located " & ImportDBName & " in Download folder - begin importing process")
		
		
		Try
			Dim OutStr As OutputStream = File.OpenOutput(File.DirInternal, "data.db",False)						'the name of the imported file
			Dim InStr As InputStream = File.OpenInput(File.DirRootExternal & "/Download/", ImportDBName)		'the source file
			File.Copy2(InStr,OutStr)
			OutStr.Close
			
			'MsgboxAsync("The database has been successfully imported.", "Import complete")
			
			If File.Exists(File.DirInternal, "data.db") = True Then
				File.Delete(File.DirInternal, "data.db")
				Log("Previous version of data.db was deleted from internal storage.")
				
				Log("Found data.db in internal storage (just copied)")
				MsgboxAsync("The database has been successfully imported. Please quit and restart the app to load the new database.", "Success")
				'db.Initialize(File.DirInternal, "data.db", False)
			Else
				Log("data.db not found in internal storage!")
			End If
			
		Catch
			MsgboxAsync(LastException.Message, "Import DB Error")
			Log(LastException)
		End Try
			
		'File.Copy(Storage.SelectDir(False), "new.db", File.dirinternal, sourceDB)
		'MsgboxAsync("DB copied","Ok")
	Else
		MsgboxAsync(ImportDBName & " not found in Download folder", "Source database not found")
	End If
	
	
	'Dim sourceDB As String = "sample.db"

	
'	If File.Exists(File.dirinternal, sourceDB) = True Then
'		MsgboxAsync("DB exists","Ok")
'		'File.Copy(Storage.SelectDir(False), "new.db", File.dirinternal, sourceDB)
'		'MsgboxAsync("DB copied","Ok")
'	Else
'		MsgboxAsync("DB not found","Nope")
'	End If
	
	'File.Copy(File.DirAssets, "sample.db", TargetDir, SQLiteDbNameToYourDevice)
End Sub


Private Sub cmdExport_Click


	
End Sub


'Creates new folder in the destination location selected
'Copies file from DirInternal, could be from anywhere
'Root in this case is the location that you select, not directory root as we usually know it
'source: https://www.b4x.com/android/forum/threads/external-storage-simple-example.117681/post-736528
Sub FiletoExtStorage(DirName As String,FileToCopy As String)
	
	Dim inpstr As InputStream  		= File.OpenInput(File.DirInternal,FileToCopy)     	'Create an Inputstream from the Sourcefile to copy
		
	Dim DirName1 As ExternalFile 	= Storage.FindDirOrCreate(Storage.Root, DirName)   	'creates the folder at selected location(Root)
	Dim destfile As ExternalFile 	= Storage.CreateNewFile(DirName1,FileToCopy)  	 	'create the file
	Dim os As OutputStream 			= Storage.OpenOutputStream(destfile)   	         	'Create an Outputstream to the destfile
		
	File.Copy2(inpstr,os)  																'Copy file
	inpstr.Close																		'Close inputstr
	os.Close															  				'Close Outputstream
	
End Sub